package com.jesuspinar.main;

import java.io.*;

public class Main{
    public static void main(String[] arg) throws Exception {
        boolean isCopied = copyFile("/Users/jesuspl/Documents/04DamPrac1/PRG/tema12/ficheros/archivo01.txt");
        if (isCopied){
            System.out.println("Done !");
        }else {
            System.out.println("File could be copied !");
        }
    }
    private static boolean copyFile(String path){
        File inputFile = new File(path);

        try (FileInputStream fis = new FileInputStream(inputFile);
             FileOutputStream fos =
                 new FileOutputStream(path+"cp"+ getExtension(inputFile))
        ){
            StringBuilder sb = new StringBuilder();
            byte[] content = fis.readAllBytes();
            double pctLoad =  0.01; // 1 = 100%
            double loadFraction = (pctLoad * content.length);

            int loadIndex = 1;
            int i = 0;

            for (int j = 0 ; j <= content.length-1; j++){
                if (loadIndex >= (int) loadFraction){
                    loadIndex = 0;
                    if (i < 100){
                        sb.append("#");
                        System.out.print((++i) +"% "+ sb );
                        System.out.print("\r");
                        Thread.sleep(50);
                    }
                }
                //Action of copy
                loadIndex++;
                fos.write(content[j]);
            }
            return true;
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
    private static void progressPrint(){
        StringBuilder sb = new StringBuilder();

        for (int i = 0 ; i <= 100 ; i++) {
            sb.setLength(0);
            for (int j = 0 ; j < i; j++) {
                sb.append("#");
            }
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            System.out.print("[" + String.format("%-100s", sb) + "] " +  i + "%");
            System.out.print("\r");
        }
    }
    private static String getExtension(File file){
        String fileName = file.toString();
        int index = fileName.lastIndexOf('.');
        if(index > 0) {
            return "." + fileName.substring(index + 1);
        }
        return ".dat";
    }
}
